# encoding: utf-8
require "csv"
class FuzzyAnalysis
	def initialize
		puts "csvファイル名を入力してください"
		msg = STDIN.gets.chomp
		@mat = Array.new
		CSV.foreach msg do |row|
			@mat << row.to_a
		end
		ro = @mat.length	#行数
		co = @mat[0].length #列数
		0.upto(ro-1) do |i|
			0.upto(co-1) do |j|
				@mat[i][j] = @mat[i][j].to_f	#float型に変換
			end
		end
		return self
	end
	#----------------------
	def data_disp(msg)
		puts msg
		ro = @mat.length	#行数
		co = @mat[0].length #列数
		0.upto(co-1) do |i|
			print(" [",(i+65).chr,"]","   ")  #65=>A 66=>B....
		end
		puts ""
		0.upto(ro-1) do |i|
			0.upto(co-1) do |j|
				printf("%1.2f %2s",@mat[i][j], " ")
			end
			puts ""
		end
		return self
	end
	def similar_coeff
		ro = @mat.length
		co = @mat[0].length
		mat01 = Array.new(co) {|i| [] }
		0.upto(co-2) do |i| 
  			(i+1).upto(co-1) do |j|
  				vr = 0.0
    			0.upto(ro-1) do |k|
      				vr += (@mat[k][i] - @mat[k][j]).abs
    			end
    			mat01[i][j] = 1.0 - vr.fdiv(ro)
    			mat01[j][i] = mat01[i][j]
  			end
		end
		0.upto(co-1) do |i|
			mat01[i][i] = 1.0
		end
		@mat = mat01
		return self
	end
	def relat_coeff
		ro = @mat.length
		co = @mat[0].length
		mat01 = Array.new(co) {|i| [] }
		0.upto(co-2) do |i|
  			(i+1).upto(co-1) do |j| #列数
  				vr1 = 0.0 ; vr2 = 0.0
    			0.upto(ro-1) do |k|
	    			if @mat[k][i] >= @mat[k][j] then		#Goguenの含意
	    				ab = 1
	     			else
      				ab = @mat[k][i]/@mat[k][j]
	     			end
  	   			if @mat[k][j] >= @mat[k][i] then
    	 				ba = 1 
	     			else
	    				ba = @mat[k][j]/@mat[k][i]
      			end
      			vr1 += ab
      			vr2 += ba
      		end
    			mat01[i][j] = vr1.fdiv(ro)
    			mat01[j][i] = vr2.fdiv(ro)
  			end
		end
		0.upto(co-1) do |i|
			mat01[i][i] = 1.0
		end
		@mat = mat01
		return self
	end

	def max_trans
		ro = @mat.size
		co = @mat[0].size
			0.upto(ro-1) do |i|  
				0.upto(co-1) do |j|
					q = []
					0.upto(co-1) do |k| 
						    q << [@mat[i][k], @mat[k][j]].min
					end
					if @mat[i][j] <= q.max  then 
						@mat[i][j] = q.max
					end
				end
			end
		return self
	end

		
	def min_trans
		ro = @mat.size
		co = @mat[0].size
		0.upto(ro-1) do |i|  
			0.upto(co-1) do |j|
				0.upto(co-1) do |k| 
					if @mat[i][j] <= [@mat[i][k], @mat[k][j]].min then 
							@mat[i][k] = @mat[i][j] if @mat[i][k] <= @mat[k][j]
							@mat[k][j] = @mat[i][j] if @mat[i][k] >= @mat[k][j]
					end
				end
			end
		end
		return self
	end
	
	def semi_order	
		ro = @mat.length 
		co = @mat[0].length
		0.upto(ro-1) do |i|
			0.upto(co-1) do |j|
				@mat[i][j] = 0.0  if @mat[i][j] < @mat[j][i] 		
				@mat[j][i] = 0.0  if @mat[i][j] > @mat[j][i] 
				if  i != j and @mat[i][j] == @mat[j][i] then
					@mat[i][j] = 0.0
		  		@mat[j][i] = 0.0
				end
			end
		end
		return self
	end
	def cluster_disp
		puts "類似関係一覧"
		ro = @mat.length
		co = @mat[0].length
		mat01 = Array.new(ro) {|i| [] }
		mat02 = Array.new(ro) {|i| [] }
		count = 1
#-----行列要素がすべて -1 でtimesループ脱出---------
		ro.times do  #ループ開始
		yy = -1
		@mat.each do |x|
			x.each do |y|
				yy = 0 if y != yy
			end
		end
		break if yy == -1 
#-------------------------------------------------
		q = []
		0.upto(ro-1) do |i| 
			0.upto(co-1) do |j|
				q << @mat[i][j]
			end
		end
		cut = q.max
#----------弁別レベルに等しいか大きければ対応する要素を-1とする------------------
		0.upto(co-1) do |i|  
			0.upto(co-1) do |j|
				@mat[i][j] = -1 if @mat[i][j] >= cut
			end
		end
		#-------------------------------------------------------------
		puts ""
		printf("%i%s %s %1.2f %2s",count,"回目","識別レベル",cut, "  \n")
		0.upto(co-1) do |i|
			print("[",(i+65).chr,"]","  ")
		end
		puts ""
		0.upto(ro-1) do |i| 
			0.upto(co-1) do |j|
				mat01[i][j] = 0 if @mat[i][j] != -1
				mat01[i][j] = 1 if @mat[i][j] == -1
				printf("%2i %2s",mat01[i][j], " ")
			end
			puts ""
		end
#ここから先は、もっとスマートにきっとなる？
		mat02 = mat01.transpose	#列行入換え
#列の小さい方から大きい方へパターン探索
		f1 = []
		0.upto(ro-1) do |i|
			f = []
			f.push((i+65).chr)
			(i+1).upto(co-1) do |j|
				f.push((j+65).chr) if mat02[i] == mat02[j] 
			end
			f = f.uniq
			f1 << f  if f.length >= 2
		end
		f11 = []
		f111 = []
		n = 0
		f1.each do |x|
			f11[n] = x
			f111 << f11[n]
			n += 1	
		end
#列の大きい方から小さい方へパターン探索
		b1 = []
		0.upto(ro-1) do |i|
			b = []
			b.push((ro-1-i+65).chr)
			(i+1).upto(co-1) do |j|
				b.push((co-1-j+65).chr)  if mat02[co-1-i]  == mat02[co-1-j]  
			end
			b = b.uniq
			b1 << b if b.length >= 2
		end
		b11 = []
		b111 = []
		n = 0
		b1.each do |x|
			b11[n] =  x
			b111 << b11[n]
			n += 1	
		end
#-----------------------------------------------------------
		f111 = f111.uniq
		b111 = b111.uniq
		if (f111[0] & b111[0] != f111[0]) then
			 p f111[0]  if f111[0] != nil
			 p b111[0].reverse  if b111[0] != nil
		else
			p f111[0]  if f111[0] != nil
		end
			p f111[1]   if f111[1] != nil && f111[1] & b111[0] != f111[1]
		count += 1
		end
	end
	def csv_write(fname)
		ro = @mat.length
		co = @mat[0].length
		CSV.open(fname,"wb") do |wr|
			0.upto(ro-1) do |i|
				wr <<	@mat[i]
			end
		end
	end	
end
#---------------------main--------------------
#mint = FuzzyAnalysis.new.data_disp("read_data").max_trans.data_disp("推移的行列")
sim_relation = FuzzyAnalysis.new.data_disp("").similar_coeff.data_disp("類似度係数行列")
sim_relation = sim_relation.max_trans.data_disp("推移的行列").cluster_disp
#ord_relation = FuzzyAnalysis.new.data_disp("").relat_coeff.data_disp("関係度係数行列")
#ord_relation = ord_relation.semi_order.data_disp("順序関係行列").max_trans.data_disp("推移的行列")
